package fr.cnam.ia;

import java.util.*;

public interface AlphaBetaInt
{
  // retourne les coups valides d'un joueur en fonction d'un tat du jeu
  public Vector coupsValides(int joueur,EtatJeu etatJeu);
		
  // retourne un nouvel tat du jeu en fonction d'un coup jou
  public EtatJeu majEtatJeu(int joueur,EtatJeu etatJeu,Object coup);
														 
  // evalue la "force" d'un tat du jeu sachant que le coup jou est "coup"
  // retourne une ResultatAlphaBeta contenant :
  //     - une valeur numrique qui traduit l'avantage du joueur
  //     - le coup jou. Si coup==null alors cela signifie que les 2 joueurs ne peuvent pa sjouer 
  //       tous les deux.
  //     - la priorit du coup (si <> 0 alors prioritaire et arrte la rcursivite
  public ResultatAlphaBeta evaluer(int joueurOrdinateur,int joueur,int joueurAdverse,Object coup,EtatJeu etatJeu);
}

