package fr.cnam.othello.vue;

import java.util.*;

import fr.cnam.othello.model.ModelOthello;
import fr.cnam.othello.controleur.*;

// Classe de definition de l'observer de robot
//
public class ObserverRobot implements Observer
{
  RobotOthello robot;
    
  // Constructeur
  //
  public ObserverRobot(RobotOthello robot)
  {
    this.robot=robot;
  }

  // Methode de notification : arg est toutes les donnees du modele
  //
  public void update(Observable o,Object arg)
  {
    if (arg!=null)
      {
        // il est important d'attendre un peu afin de laisser le temps
        // au cycle de notification prcdent de se terminer.
        //
        System.out.println("ObserverRobot : update");
        try{Thread.sleep(200);}catch(Exception ex){}
        robot.jouerCoup((DataVueOthello)arg);
      }
  }
}